Subject: bug#51591: webkitgtk fails to build on i686-linux; possibly a clang issue

From: Liliana Marie Prikler <[email-masked]>
Date: Thu, 04 Nov 2021 09:03:51 +0100

Hi,

Am Mittwoch, den 03.11.2021, 17:04 -0400 schrieb Mark H Weaver:
> Earlier, I wrote:
> > libwebkit2gtk-4.0.so fails to link on i686-linux, due to an
> > undefined reference to '__mulodi4'.
> 
> Here are some relevant links:
> 
>   https://bugs.webkit.org/show_bug.cgi?id=190208
>   https://trac.webkit.org/changeset/272140/webkit
>   https://github.com/android/ndk/issues/506
This error does not occur when compiling with GCC [1].

However, now dependant packages fail to link Webkit [2].  We might have
to add GCC 11 to all of them -- or at least to a fair number.  I've
verified that gnome-online-accounts builds with GCC 11 added, we might
want to make sure we check the rest of the gnome package as well.

On that note, which GCC will be the standard once core-updates-frozen
is merged?  If it's not GCC 11 – say GCC 10 – we might want to try to
get Webkit building with that instead, so that at least after the merge
we're clean on that front.

> >   https://ci.guix.gnu.org/build/1428233/details
> [...]
> > [100%] Linking CXX shared library ../../lib/libwebkit2gtk-4.0.so
> > cd /tmp/guix-build-webkitgtk-2.34.1.drv-0/build/Source/WebKit &&
> > /gnu/store/4mlbaklbibcdgprxg7vp42vkafs69v9i-cmake-minimal-
> > 3.16.5/bin/cmake -E cmake_link_script
> > CMakeFiles/WebKit.dir/link.txt --verbose=1
> > /gnu/store/dbcwl680w24rf2dn2pk3gx9nmvz7rl9c-clang-
> > 11.0.0/bin/clang++ -fPIC -Wextra -Wall -mfpmath=sse -msse2 [...]
> 
> Also, I just noticed that "-mfpmath=sse -msse2" is being passed on
> the compile command line.  Historically, we've chosen not to assume
> the availability of SSE or SSE2 on i686-linux, so it would be good to
> inhibit those flags.
This is still true for the GCC build.  Could you add the necessary
flags to disable them?

Cheers,
Liliana

[1] http://ci.guix.gnu.org/build/1530117/log/raw
[2] http://ci.guix.gnu.org/build/1530484/log/raw